

<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  
  <title>&lt;no title&gt; &mdash; posydon 0+untagged.3754.gf69f455.dirty documentation</title>
  

  
  <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />

  
  

  
  

  

  
  <!--[if lt IE 9]>
    <script src="../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
        <script src="../_static/jquery.js"></script>
        <script src="../_static/underscore.js"></script>
        <script src="../_static/doctools.js"></script>
        <script src="../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../_static/js/theme.js"></script>

    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../index.html" class="icon icon-home"> posydon
          

          
          </a>

          
            
            
              <div class="version">
                0+untagged.3754.gf69f455.dirty
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        
        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../install/index.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../run_mesa_grids/inifile.html">Configuration files for POSYDON</a></li>
<li class="toctree-l1"><a class="reference internal" href="../run_mesa_grids/dynamic/dynamic.html">Run a Dynamic MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../run_mesa_grids/fixed/fixed.html">Run a Fixed MESA Grid</a></li>
<li class="toctree-l1"><a class="reference internal" href="../PSyGrid/PSyGrid.html">The PSyGrid Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../PSyGrid/plot2D/plot2D.html">Showcase of 2D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../PSyGrid/plot1D/plot1D.html">Showcase of 1D plotting functionalities</a></li>
<li class="toctree-l1"><a class="reference internal" href="../SingleStar/SingleStar.html">The Single Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../BinaryStar/BinaryStar.html">The Binary Star Object</a></li>
<li class="toctree-l1"><a class="reference internal" href="../visualization/VH_diagram.html">Van den Heuvel diagrams</a></li>
</ul>

            
          
        </div>
        
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">posydon</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          

















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../index.html" class="icon icon-home"></a> &raquo;</li>
        
      <li>&lt;no title&gt;</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
          
            <a href="../_sources/api/posydon.binary_evol.binarystar.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <span class="target" id="module-posydon.binary_evol.binarystar"></span><p>The binary object describes current and past state of the binary.</p>
<p>The binary object is composed of two star objects and contains the current and past
states of the binary. Only parameters in the BINARYPROPERTIES list are stored in the
history. The current parameter value of the star object is accessed as,
e.g. <cite>binary.orbital_period</cite> while its past history with
<cite>binary.orbital_period_history</cite>. The two stars are accesses as, e.g.
<cite>binary.star_1.mass</cite> while his past history with <cite>binary.star_1.mass_history</cite>.</p>
<dl class="py class">
<dt id="posydon.binary_evol.binarystar.BinaryStar">
<em class="property">class </em><code class="sig-prename descclassname">posydon.binary_evol.binarystar.</code><code class="sig-name descname">BinaryStar</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">star_1</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">star_2</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">index</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="n">properties</span><span class="o">=</span><span class="default_value">None</span></em>, <em class="sig-param"><span class="o">**</span><span class="n">binary_kwargs</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/binary_evol/binarystar.html#BinaryStar"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.binary_evol.binarystar.BinaryStar" title="Permalink to this definition">¶</a></dt>
<dd><p>Bases: <a class="reference external" href="https://docs.python.org/3/library/functions.html#object" title="(in Python v3.9)"><code class="xref py py-class docutils literal notranslate"><span class="pre">object</span></code></a></p>
<p>A class containing the state and history of a stellar binary.</p>
<p>Constructor function for BinaryStar.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>properties</strong> (<a class="reference internal" href="posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.SimulationProperties" title="posydon.binary_evol.simulationproperties.SimulationProperties"><em>SimulationProperties</em></a>) – Instance of the SimulationProperties class (default: None)</p></li>
<li><p><strong>star_1</strong> (<a class="reference internal" href="posydon.binary_evol.singlestar.html#posydon.binary_evol.singlestar.SingleStar" title="posydon.binary_evol.singlestar.SingleStar"><em>SingleStar</em></a>) – The first star of the binary.</p></li>
<li><p><strong>star_2</strong> (<em>Star</em>) – The second star of the binary.</p></li>
<li><p><strong>**binary_kwargs</strong> (<em>dictionary</em>) – List of initialization parameters for a binary</p></li>
</ul>
</dd>
</dl>
<dl class="py method">
<dt id="posydon.binary_evol.binarystar.BinaryStar.append_state">
<code class="sig-name descname">append_state</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/binary_evol/binarystar.html#BinaryStar.append_state"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.binary_evol.binarystar.BinaryStar.append_state" title="Permalink to this definition">¶</a></dt>
<dd><p>Update the history of the binaries’ properties.</p>
</dd></dl>

<dl class="py method">
<dt id="posydon.binary_evol.binarystar.BinaryStar.evolve">
<code class="sig-name descname">evolve</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/binary_evol/binarystar.html#BinaryStar.evolve"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.binary_evol.binarystar.BinaryStar.evolve" title="Permalink to this definition">¶</a></dt>
<dd><p>Function to evolve a binary from start to finish.</p>
</dd></dl>

<dl class="py method">
<dt id="posydon.binary_evol.binarystar.BinaryStar.from_df">
<em class="property">classmethod </em><code class="sig-name descname">from_df</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">dataframe</span></em>, <em class="sig-param"><span class="o">**</span><span class="n">kwargs</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/binary_evol/binarystar.html#BinaryStar.from_df"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.binary_evol.binarystar.BinaryStar.from_df" title="Permalink to this definition">¶</a></dt>
<dd><p>Convert a binary from a pandas DataFrame to BinaryStar
instance.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>dataframe</strong> (<em>Pandas DataFrame</em>) – data to turn into a BinaryStar instance.</p></li>
<li><p><strong>index</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.9)"><em>int</em></a><em>, </em><em>optional</em>) – Sets the binary index.</p></li>
<li><p><strong>extra_columns</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.9)"><em>list</em></a><em>, </em><em>optional</em>) – Column names to be added directly to binary
not in BINARYPROPERTIES.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p></p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>New instance of BinaryStar</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt id="posydon.binary_evol.binarystar.BinaryStar.from_run">
<em class="property">static </em><code class="sig-name descname">from_run</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">run</span></em>, <em class="sig-param"><span class="n">history</span><span class="o">=</span><span class="default_value">False</span></em>, <em class="sig-param"><span class="n">profiles</span><span class="o">=</span><span class="default_value">False</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/binary_evol/binarystar.html#BinaryStar.from_run"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.binary_evol.binarystar.BinaryStar.from_run" title="Permalink to this definition">¶</a></dt>
<dd><p>Create a BinaryStar object from a PSyGrid run.</p>
</dd></dl>

<dl class="py method">
<dt id="posydon.binary_evol.binarystar.BinaryStar.reset">
<code class="sig-name descname">reset</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">properties</span><span class="o">=</span><span class="default_value">None</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/binary_evol/binarystar.html#BinaryStar.reset"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.binary_evol.binarystar.BinaryStar.reset" title="Permalink to this definition">¶</a></dt>
<dd><p>Reset the binary to its ZAMS state.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>properties</strong> (<a class="reference internal" href="posydon.binary_evol.simulationproperties.html#posydon.binary_evol.simulationproperties.SimulationProperties" title="posydon.binary_evol.simulationproperties.SimulationProperties"><em>SimulationProperties</em></a>) – Instance of the SimulationProperties class (default: None)</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt id="posydon.binary_evol.binarystar.BinaryStar.restore">
<code class="sig-name descname">restore</code><span class="sig-paren">(</span><em class="sig-param"><span class="n">i</span><span class="o">=</span><span class="default_value">0</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/binary_evol/binarystar.html#BinaryStar.restore"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.binary_evol.binarystar.BinaryStar.restore" title="Permalink to this definition">¶</a></dt>
<dd><p>Restore the object to the i-th state.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>i</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#int" title="(in Python v3.9)"><em>int</em></a>) – Index of the binary object history to reset the binary to. By default
i == 0, meaning that the star will be restored to its initial state.</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt id="posydon.binary_evol.binarystar.BinaryStar.run_step">
<code class="sig-name descname">run_step</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/binary_evol/binarystar.html#BinaryStar.run_step"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.binary_evol.binarystar.BinaryStar.run_step" title="Permalink to this definition">¶</a></dt>
<dd><p>Evolve the binary through one evolutionary step.</p>
</dd></dl>

<dl class="py method">
<dt id="posydon.binary_evol.binarystar.BinaryStar.switch_star">
<code class="sig-name descname">switch_star</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/binary_evol/binarystar.html#BinaryStar.switch_star"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.binary_evol.binarystar.BinaryStar.switch_star" title="Permalink to this definition">¶</a></dt>
<dd><p>Switch stars.</p>
</dd></dl>

<dl class="py method">
<dt id="posydon.binary_evol.binarystar.BinaryStar.to_df">
<code class="sig-name descname">to_df</code><span class="sig-paren">(</span><em class="sig-param"><span class="o">**</span><span class="n">kwargs</span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/posydon/binary_evol/binarystar.html#BinaryStar.to_df"><span class="viewcode-link">[source]</span></a><a class="headerlink" href="#posydon.binary_evol.binarystar.BinaryStar.to_df" title="Permalink to this definition">¶</a></dt>
<dd><p>Return history parameters from the binary in a DataFrame.
Includes star 1 and 2 (S1, S2) data and an extra column ‘binary_index’.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>extra_columns</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.9)"><em>list</em></a>) – Extra binary parameters to return in DataFrame that are not
included in BINARYPROPERTIES.
Can be used in combination with <cite>only_select_columns</cite>.
Assumes names have no suffix.</p></li>
<li><p><strong>ignore_columns</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.9)"><em>list</em></a>) – Names of binary parameters to ignore.
Assumes names have <cite>_history</cite> suffix.</p></li>
<li><p><strong>only_select_columns</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#list" title="(in Python v3.9)"><em>list</em></a>) – Names of the only columns to include.
Assumes names have <cite>_history</cite> suffix.
Can be used in combination with <cite>extra_columns</cite>.</p></li>
<li><p><strong>null_value</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#float" title="(in Python v3.9)"><em>float</em></a>) – Replace all None values with something else (for saving).
Default is np.NAN.</p></li>
<li><p><strong>include_S1</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.9)"><em>bool</em></a>) – Choose to include star 1 or 2 data to the DataFrame.
The default is to include both.</p></li>
<li><p><strong>include_S2</strong> (<a class="reference external" href="https://docs.python.org/3/library/functions.html#bool" title="(in Python v3.9)"><em>bool</em></a>) – Choose to include star 1 or 2 data to the DataFrame.
The default is to include both.</p></li>
<li><p><strong>S1_kwargs</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#dict" title="(in Python v3.9)"><em>dict</em></a>) – Kwargs to pass to each star’s ‘to_df’ method. (Extra and ignore columns)</p></li>
<li><p><strong>S2_kwargs</strong> (<a class="reference external" href="https://docs.python.org/3/library/stdtypes.html#dict" title="(in Python v3.9)"><em>dict</em></a>) – Kwargs to pass to each star’s ‘to_df’ method. (Extra and ignore columns)</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p></p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>pandas DataFrame</p>
</dd>
</dl>
</dd></dl>

</dd></dl>



           </div>
           
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>
        &#169; Copyright 2019, Tassos Fragkos.

    </p>
  </div>
    
    
    
    Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    
    provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>
        </div>
      </div>

    </section>

  </div>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>